#!/bin/sh

# NOTE: Must be run as root, so you probably need to setup sudo for this.

ls /dev/disk/by-id/* | grep -ve '-part' -ve '/wwn-' |
while read DISK
do
    DISKDEV=`ls -l $DISK | awk -F/ '{print $NF}'`
    DISKNAME=`echo $DISK | awk -F/ '{print $5}'` | tr ":" "_"

    #check if disk is removable
    RM=0
    RM=`cat /sys/block/$DISKDEV/removable`
    if test $RM -ne 0
    then
        continue
    fi

    hddtemp=`sudo smartctl -A $DISK | grep Temperature_Celsius | awk '{print $10}'`

    TEMP=": $hddtemp"
    if [[ $hddtemp == "" ]]
    then
        TEMP="- No Temp Sensor Found"
        COLOR="4&clear"
    elif test $hddtemp -gt 55
    then
        COLOR="1&red"
    elif test $hddtemp -ge 50
    then
        COLOR="2&yellow"
    else
        COLOR="3&green"
    fi

    echo "${COLOR} $DISKNAME $TEMP"

done > /tmp/hddcheck

COLOR=`cat /tmp/hddcheck | awk '{print $1}' | sort | uniq | head -1 | cut -c3-`

# Report status to Xymon Server
$XYMON $XYMSRV "status ${MACHINE}.hddtemp ${COLOR} Hard Drive Temperatures (in &degC)

`cat /tmp/hddcheck | cut -c2-`
"

rm -f /tmp/hddcheck

exit 0
